
# Installation

1. Clonez ce dépôt ou récupérez simplement les fichiers.
2. Assurez-vous d’avoir Python 3.9+ installé.
3. Installez les dépendances éventuellesment manquantes 
```bash
python -m pip install -r requirements.txt
```
# Utilisation 

Les paramètres du script principal `automatic_test.py` sont :

--xlia_fp : chemin vers le fichier XLIA.

--json_fp : chemin vers le fichier JSON décrivant les tests.

--bb_fp : chemin vers le SUT « black box ».

--max_nodes : nombre maximal de nœuds visités (par défaut 100).

## Exemple d'utilisation

```bash
python automatic_test.py --xlia_fp IOSMs/ATM.xlia --json_fp ./TEST_CASES/testcases_ATM.json --bb_fp SUTs/atm_SUT.py --max_nodes 100
```

# Structure du projet

• IOSMS/  
    – Contient les machines à états au format XLIA (ATM.xlia, Bank.xlia).  
• TEST_CASES/  
    – Regroupe des fichiers JSON décrivant différents scénarios de test (testcases_ATM.json, testcases_bank.json).  
• deprecated/  
    – Divers scripts plus anciens (graph_deprecated.py, oracle_multigraph_deprecated.py) conservés à titre d’archive.  
• Temporized_IOSMs (incomplete)/  
    – Les équivalents des scripts (multigraph.py, oracle.py, IOSM.py) avec prise en compte des conditions de guards.
    – Il manque une prise en compte de la modification des variables lors de quelques transitions.  
• automatic_test.py  
    – Script permettant d’exécuter automatiquement des tests sur les IOSMs.  
• README.md  
    – Documentation rapide pour prendre en main le projet.
