import copy
from multigraph import BipartiteMultiGraph

class Strat:
    def __init__(self, t, g:BipartiteMultiGraph):
        self.t = t
        self.n = g.n
        self.w = [[set([]) for _ in range(self.n)] for _ in range(self.n)]
        self.g = g
        self.rank = {}
        
    def calc_w (self):
        """Calcule les ensembles w[i][j]"""
        self.w[0][0].add(self.t)
        for j in range(self.n):

            for i in range(self.n-1):
                self.w[i+1][j] = copy.deepcopy(self.w[i][j])
                for p in self.g.Vb:
                    for q in self.w[i][j]:
                        if(p!= "bot" and q in self.g.E[p]):
                            self.w[i+1][j].add(p)
                            break
                for p in self.g.Vr: 
                    ok = True
                    for q in self.g.Vb:
                        if((q!="bot") and (not(q in self.w[i][j])) and ( q in self.g.E[p])):
                            ok = False
                            break
                    if(ok):
                        self.w[i+1][j].add(p) 
            kj = self.n-1
            for i in range(self.n-1):
                if(self.w[i+1][j] == self.w[i][j]):
                    kj = i
                    break
            if(j+1 < self.n):
                self.w[0][j+1] = copy.deepcopy(self.w[kj][j])
                for p in self.g.Vr:
                    for q in self.g.Vb:
                        for r in self.g.Vb:
                            if( q!="bot" and (q in self.g.E[p]) and (r in self.g.E[p]) and (q in self.w[kj][j]) and (not r in self.w[kj][j])):
                                self.w[0][j+1].add(p)
                                break


    def calc_rank(self):
        for p in self.g.Vb + self.g.Vr:
            self.rank[p]= (float("inf"), float("inf"))
            for i in range(self.n):
                for j in range(self.n):
                    if p in self.w[i][j]:
                        self.rank[p]=min(self.rank[p], (j, i)) #assume c deja lexicographique

    def strategy(self, u): #prendre rang min

        min_rank = (float("inf"), float("inf"))
        mnv =-1
        for v in self.g.E[u]:
            if min_rank >= self.rank[v]:
                min_rank = self.rank[v]
                mnv = v

        return mnv
            

