from multigraph import *
from calc_strat import Strat

class Oracle():
    def __init__(self, MAX_NODE_VISITED: int, g: BipartiteMultiGraph):
        self.g = g
        self.MAX_NODE_VISITED = MAX_NODE_VISITED
        self.current_node_visited = 0
        self.phase = "pre"
        self.u = g.idle
        self.x_idx = 0

    def new_x(self, x: list[int]): #recevoir un nouveau x
        self.x = x
        self.n_x = len(x)
        self.current_node_visited = 0
        self.strat = Strat(x[0], self.g)
        self.strat.calc_w()
        self.strat.calc_rank()


    def update_phases(self):

        if(self.phase == "pre"):
            if(len(self.x) == 1 and self.u == self.x[0]): #on entre dans la phase during et direct apres c la phase finale.
                self.phase = "post"
            elif(self.u == self.x[0]):
                self.phase = "during"
                self.x_idx = 0

        elif(self.phase == "during"):
            if(self.x[self.x_idx] == self.u): ## si on reste dans la phase intermediaire

                if(self.x_idx == self.n_x -1):  #on a fini la sequence
                    self.phase = "post"
                    self.strat = Strat(self.g.idle, self.g)
                    self.strat.calc_w()
                    self.strat.calc_rank()
                    

            else:
                self.phase = "pre"
            #ne pas retirer la fonction dans update move car elle verifie si on reste bien dans la sequence des x. ici pas necessaire
        else:#a la fin, on s'en fiche...
            pass


    def update_move(self, transi:str):#quand le joueur adverse joue un coup

        if(transi!="__NotMyTurn"):
            self.current_node_visited+=1
            for v in self.g.E[self.u]:
                if self.g.E_label[self.u,v] == transi:
                    self.u = v
                    break
            
            if(self.phase == "during"):
                self.x_idx+=1
            self.update_phases()
            self.output_variables()
        else:
            
            self.next_move()

        
    def check_win(self):
        if( (self.u == "bot")  or (self.phase == "post" and self.u == self.g.idle) ) :
            print("C'EST FINI, PARTIE GAGNANTE!")
            return True
        else:
            return False
    def next_move(self):
        self.current_node_visited+=1
        transi_taken = ""
        v = 0
        if(self.phase == "pre"):
            v =  self.strat.strategy(self.u)
        elif(self.phase == "during"):
            self.x_idx+=1
            v = self.x[self.x_idx]
                
        elif(self.phase == "post"):
            v = self.strat.strategy(self.u)
        transi_taken = self.g.E_label[self.u,v]

        if(self.g.E_label[self.u,v] == "tau" and self.strat.rank[v]!=(999999,999999)): #on a est resté dans un état interne...
            self.u = v
            self.update_phases()
            return None
        self.u = v
        self.update_phases()
        self.output_variables()
        return transi_taken, self.u
    

    def output_variables(self):
        pass

       # for var in self.g.needed_variables :
         #   print("var", var, "\n")