#distributed_to_IOSM
from IOSM import *
import itertools


class Distr_to_IOSM:
    def __init__(self, S):
        self.S = S
        self.n = len(S)
        #self.n_Si = [len(Si) for Si in S]
        self.Sg = set()
        for etat in itertools.product(*[s.states for s in self.S]):
            self.Sg.add(etat)
        self.s0g = tuple(i.idle_state for i in self.S)
        self.Transis = set()
        self.A = set()
        for Si in self.S:
            for a in Si.transitions:
                self.A.add(a.name)
        
    def transform(self) -> IOSM:
        k=0
        for a in list(self.A):
            for s_p in self.Sg:
                s_prim = list(s_p)
                id_a = [i for i in range(self.n) if a in [j.name for j in self.S[i].transitions]] #ensemble des s_i différents
                for tr_id_a in itertools.product(*[self.S[i].transitions for i in id_a]): #produits des transitions des s_i différents
                    #print([(s_p[id_a[i]],s_prim[id_a[i]],tr_id_a[i].from_node,tr_id_a[i].to_node) for i in range(len(id_a))])                    
                    #if all([(s_p[id_a[i]],s_prim[id_a[i]])==(tr_id_a[i].from_node,tr_id_a[i].to_node) for i in range(len(id_a))]):
                    #    print("yes")
                    #if all([tr_id_a[i].name == a and (s_p[id_a[i]],s_prim[id_a[i]])==(tr_id_a[i].from_node,tr_id_a[i].to_node) for i in range(len(id_a))]) and len(tr_id_a)>0
                    if all([tr_id_a[i].name == a and s_p[id_a[i]]==tr_id_a[i].from_node for i in range(len(id_a))]) and len(tr_id_a)>0:#(si,a,s′i)∈→i:
                        if any([tr_id_a[j].t_type == "internal" for j in range(len(id_a))]):
                            typetransi = "internal"
                        else:
                            typetransi = tr_id_a[0].t_type #Une transi est dans id_a si elle est activée par le même mot, donc reste du même type.

                        for i in range(len(id_a)):
                            if i in id_a:
                                    s_prim[i] = tr_id_a[i].to_node
                        vars = []
                        for i in range(len(id_a)):
                            if not tr_id_a[i].domains in vars:
                                vars.append(tr_id_a[i].domains)
                        self.Transis.add(Transition(
                                            name=a,
                                            t_type=typetransi,
                                            guard_condition=' && '.join([tr_id_a[i].guard_condition for i in range(len(id_a))]),
                                            from_node=s_p,
                                            to_node=tuple(s_prim),
                                            domains=tuple(vars)  # Explicit tuple of Variable objects
                                                ))
        return IOSM(states=set(self.Sg), transitions=self.Transis, idle_state=self.s0g)
                    


if __name__ == "__main__":
    iosm_system = Distr_to_IOSM([IOSM_from_XLIA("IOSMS/ATM_MODIFIED.xlia"),IOSM_from_XLIA("IOSMS/BANK_MODIFIED.xlia")])
    iosm = iosm_system.transform()
    #print(iosm)
    #print(len(iosm.states))
    #print("\n".join(map(str, iosm.transitions)))